%global debug_package %{nil}
%global gituser denoland
%global gitname deno

Name:          deno
Version:       2.3.3
Release:       1%{?dist}
Summary:       A secure JavaScript and TypeScript runtime
License:       MIT
Group:         Development/Language
URL:           https://github.com/%{gituser}/%{gitname}
Source0:       %{url}/archive/refs/tags/v%{version}.tar.gz#/%{gituser}-%{name}-%{version}.tar.gz
# Patch1:        %%{url}/pull/16588.patch#/update_crates_16588.patch
BuildRequires: rust-packaging protobuf-compiler cmake
BuildRequires: llvm-devel clang-devel
BuildRequires: devscripts

%description
Deno is a simple, modern and secure runtime for JavaScript and
TypeScript that uses V8 and is built in Rust.

%prep
%autosetup -p1 -n %{name}-%{version}

%build
%set_build_flags
# export CFLAGS=$(echo "$CFLAGS -Wno-error=implicit-function-declaration")
export RUSTFLAGS="%{build_rustflags}"
export RUSTFLAGS=$(echo "$RUSTFLAGS" | sed -e 's|debuginfo=2|debuginfo=0|')
cargo build --release --verbose

%install
# control flow protection not supported
hardening-check -v --nocfprotection --nobranchprotection target/release/%{name}

install -Dm755 target/release/%{name} %{buildroot}%{_bindir}/%{name}

%files
%{_bindir}/%{name}
%doc README.md Releases.md
%license LICENSE.md

%changelog
* Sun May 25 2025 samoht0 <https://copr.fedorainfracloud.org/coprs/samoht0/> 2.3.3
- update 2.3.3
- history cleanup
